unit FormChoixCat;
{$mode delphi}
interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Menus, StdCtrls, Buttons, Donnees,GR32;
type
  TEtatChCat = (ecEditSimple,ecEditComp,ecAjoutSimple,ecAjoutSimpleComp,ecAjoutComp,ecConsult);

  { TFChoixcat }

  TFChoixcat = class(TForm)
    BOK: TBitBtn;
    BAnnuler: TBitBtn;
    ColorDialog: TColorDialog;
    PanCouleur: TPanel;
    PanCouleurComp: TPanel;
    PCatSimple: TPanel;
    Label4: TLabel;
    PNouvCatSimple: TPanel;
    Label5: TLabel;
    EditNom: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CheckActive: TCheckBox;
    PCatComp: TPanel;
    Label6: TLabel;
    PNouvCatComp: TPanel;
    Label7: TLabel;
    EditNomComp: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CheckActiveComp: TCheckBox;
    Panel1: TPanel;
    Label11: TLabel;
    ComboCatAss1: TComboBox;
    ComboLien: TComboBox;
    ComboCatAss2: TComboBox;
    BFermer: TBitBtn;
    RectCible: TPanel;
    Label12: TLabel;
    BSuppr: TButton;
    RectCible2: TPanel;
    BSuppr2: TButton;
    procedure CouleurClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckActiveChange(Sender: TObject);
    procedure BOKClick(Sender: TObject);
    procedure BFermerClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PCatCompDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PCatCompDragOver(Sender, Source: TObject; X, Y: Integer;
        State: TDragState; var Accept: Boolean);
    procedure PCatSimpleDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PCatSimpleDragOver(Sender, Source: TObject; X, Y: Integer;
          State: TDragState; var Accept: Boolean);
    //procedure PCatSimpleDragLeave(Sender: TObject);
    procedure BAnnulerClick(Sender: TObject);
   // procedure PCatCompDragLeave(Sender: TObject);
    procedure BSupprClick(Sender: TObject);
    procedure BSuppr2Click(Sender: TObject);
  private
    { Déclarations privées }
    EditSurvole : integer; // pour stocker le Tag de l'edit survolé . Si aucun : -1
    procedure EDitEnter(Sender: TObject);
    procedure EditDragOver(Sender, Source: TObject; X, Y: Integer;
          State: TDragState; var Accept: Boolean);
    procedure EditDragDrop(Sender, Source: TObject; X, Y: Integer);
  public
    { Déclarations publiques }
    LesNoms : Array of TEdit;
    LesCouleurs : Array of TPanel;
    Mescouleurs : array of TColor32;
    Actives : Array of TCheckBox;
    LesNomsComp : Array of TEdit;
    LesCouleursComp : Array of TPanel;
    ActivesComp : Array of TCheckBox;
    Nb,NbComp : integer;
    Etat : TEtatChCat;
    NumSelect : integer;
    PeutChanger : Boolean;
    LesRestrictions : Array of TCategorie;
    CatRestr : TCategorie;
    CatSimpleEnCours : TCategorie;
    MesCategoriesS : array of TCategorie;
    MesCategoriesC : array of TCategorie;
    InterdireS : Array of Boolean;
    InterdireC : Array of Boolean;
    procedure initialise(LEtat : TEtatChCat); //(ecEditSimple,ecEditComp,ecAjoutSimple,ecAjoutComp,ecConsult);
    procedure SupprimerComp(Ind : integer);
    procedure Ajouter;
    procedure RAZ;
    function CouleurSuivante : TColor32;
  end;
Const
  clQuasi = $FFFFFE;

var
  FChoixcat: TFChoixcat;

implementation

{$R *.lfm}


procedure TFChoixcat.EDitEnter(Sender: TObject);
Var
  EditSel : TEdit;
begin
  if (Etat = ecEditSimple) and (Sender is TEdit) then
    begin
      EditSel :=(Sender as TEdit);
      NumSelect := EditSel.Tag;
      if NumSelect > -1 then
        begin
          BSuppr.Top := EditSel.Top;
          BSuppr.Visible := Not InterdireS[NumSelect];
          BSuppr2.Visible := False;
        end
      else if Numselect <=-2 then
        begin
          BSuppr2.Top := EditSel.Top;
          BSuppr2.Visible := Not InterdireC[-2-NumSelect];
          BSuppr.Visible := False;
        end;
    end;
end;

procedure TFChoixcat.initialise(LEtat : TEtatChCat); //(ecEditSimple,ecEditComp,ecAjoutSimple,ecAjoutComp,ecConsult);
Var
  i,j,k : integer;
  MonMessage : string;
  Interdire : Boolean;
  htf : integer;
begin
  Etat :=LEtat;
  PNouvCatComp.Visible := False;
  PNouvCatSimple.Visible := False;
  PCatComp.Visible := False;
  BSuppr.Visible := False;
  BSuppr2.Visible := False;
  BOK.Visible := True;
  BAnnuler.Visible := True;
  PeutChanger := True;
  ComboLien.Enabled:=True;
  for i := 0 to Nb - 1 do
    begin
      LesNoms[i].ReadOnly := True;
      LesNoms[i].DragMode := TDragMode.dmManual;
      LesNoms[i].OnDragOver:=Nil;
      LesNoms[i].OnDragDrop:=Nil;
      Actives[i].Visible:=False;
    end;
  for i := 0 to Nbcomp - 1 do
    begin
      LesNomsComp[i].ReadOnly := True;
      LesNomscomp[i].DragMode := TDragMode.dmManual;
      LesNomsComp[i].OnDragOver:=Nil;
      LesNomsComp[i].OnDragDrop:=Nil;
      ActivesComp[i].Visible:=False;
    end;
  if (CatRestr = nil) and (Etat = ecAjoutSimpleComp) then
    Etat := ecAjoutSimple;
  Case Etat of
    ecEditSimple : //PCatSimple.Height := 56 + (Nb+1) * (EditNom.Height+5);
      begin
        CatRestr := nil;
        PCatSimple.Height := 56 + Nb * (EditNom.Height+5);
        if NbComp > 0 then
          begin
            PCatComp.Height := 56 + NbComp * (EditNom.Height+5);
            PCatComp.Visible := True;
          end;
        // copie les Catégories de données
        SetLength(MesCategoriesS,LesCategories.NbCategorieDeBase);
        SetLength(InterdireS,LesCategories.NbCategorieDeBase);
        SetLength(MesCategoriesC,LesCategories.NbCategorieComp);
        SetLength(InterdireC,LesCategories.NbCategorieComp);
        for i := 0 to LesCategories.NbCategorieDeBase - 1 do
          begin
            MesCategoriesS[i] := LesCategories.LesCategoriesDeBase[i];
            LesCategories.LesCategoriesDeBase[i].AncienNom:=LesCategories.LesCategoriesDeBase[i].Nom;
            for k := 0 to Length(LesRestrictions) - 1 do
              begin
                CatRestr := LesRestrictions[k];
                InterdireS[i] := (MesCategoriesS[i] = CatRestr);
                if (Not InterdireS[i]) and (CatRestr <> nil) then
                  begin
                    for j := 0 to Length(CatRestr.CatAscendants)-1 do
                      begin
                        InterdireS[i] := (MesCategoriesS[i] = CatRestr.CatAscendants[j]);
                        if InterdireS[i] then
                          Break;
                      end;
                  end;
              end;
            Actives[i].Enabled:=Not InterdireS[i];
            if InterdireS[i] then Actives[i].Checked:= False;
          end;
        for i := 0 to LesCategories.NbCategorieComp - 1 do
          begin
            MesCategoriesC[i] := LesCategories.LesCategoriesComp[i];
            LesCategories.LesCategoriesComp[i].AncienNom:=LesCategories.LesCategoriesComp[i].Nom;
            InterdireC[i] := (MesCategoriesC[i] = CatRestr);
            if (Not InterdireS[i]) and  (CatRestr <> nil)  then
              begin
                for j := 0 to Length(CatRestr.CatAscendants)-1 do
                  begin
                    InterdireC[i] := (MesCategoriesC[i] = CatRestr.CatAscendants[j]);
                    if InterdireC[i] then
                      Break;
                  end;
              end;
          end;
        //rend les Edit éditables
        for i := 0 to Nb - 1 do
          begin
            LesNoms[i].ReadOnly := False;
            if Nb > 1 then
              begin
                LesNoms[i].DragMode := TDragMode.dmAutomatic;
                LesNoms[i].OnDragOver:=EditDragOver;
                LesNoms[i].OnDragDrop:=EditDragDrop;
              end;
          end;
        for i := 0 to Nbcomp - 1 do
          begin
            LesNomsComp[i].ReadOnly := False;
            if NbComp > 1 then
              begin
                LesNomsComp[i].DragMode := TDragMode.dmAutomatic;
                LesNomsComp[i].OnDragOver:=EditDragOver;
                LesNomsComp[i].OnDragDrop:=EditDragDrop;
              end;
          end;
      end;
    ecAjoutSimple :
      begin
        PCatSimple.Height := 56 + Nb * (EditNom.Height+5)+PNouvCatSimple.Height;
        EditNom.ReadOnly := False;
        PanCouleur.Enabled:=True;
        CheckActive.Enabled:=True;
        CheckActive.Checked:=True;
        PNouvCatSimple.Visible := True;
      end;
    ecAjoutSimpleComp :
      begin
        PCatSimple.Height := 56 + Nb * (EditNom.Height+5)+PNouvCatSimple.Height;
        EditNom.ReadOnly := True;
        EditNom.Text :='Cat'+IntToStr(Nb);
        PanCouleur.Color := clQuasi;  //White
        PanCouleur.Enabled:=False;
        CheckActive.Enabled:=False;
        CheckActive.Checked:=False;
        PNouvCatSimple.Visible := True;
        PNouvCatComp.Visible := True;
        PCatComp.Height := 56 + NbComp * (EditNom.Height+5)+PNouvCatComp.Height;
        PCatComp.Visible := True;
        PanCouleurComp.Color := WinColor(CouleurSuivante);
        ComboCatAss1.Clear;
        ComboCatAss2.Clear;
        ComboCatAss1.Items.Add(EditNom.Text);
        ComboLien.ItemIndex:=0;
        ComboLien.Enabled:=False;
        ComboCatAss2.Items.Add(CatRestr.Nom);
        ComboCatAss1.ItemIndex := 0;
        ComboCatAss2.ItemIndex := 0;
      end;
    ecAjoutComp :
      begin
        if LesCategories.NbCategorieDeBase < 2 then
          begin
            MonMessage := 'il n''y a pas assez de catégories simples à combiner';
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            modalResult := mrAbort;
            Close;
          end
        else
          begin
            PCatSimple.Height := 56 + Nb * (EditNom.Height+5);
            PNouvCatComp.Visible := True;
            PCatComp.Height := 56 + NbComp * (EditNom.Height+5)+PNouvCatComp.Height;
            PCatComp.Visible := True;
            PanCouleurComp.Color := WinColor(CouleurSuivante);
            ComboCatAss1.Clear;
            ComboCatAss2.Clear;
            For i := 0 to LesCategories.NbCategorieDeBase - 1 do
              begin
                ComboCatAss1.Items.AddObject(LesCategories.LesCategoriesDeBase[i].Nom,LesCategories.LesCategoriesDeBase[i]);
                ComboCatAss2.Items.AddObject(LesCategories.LesCategoriesDeBase[i].Nom,LesCategories.LesCategoriesDeBase[i]);
              end;
            For i := 0 to LesCategories.NbCategorieComp - 1 do
              begin
                ComboCatAss1.Items.AddObject(LesCategories.LesCategoriesComp[i].Nom,LesCategories.LesCategoriesComp[i]);
                ComboCatAss2.Items.AddObject(LesCategories.LesCategoriesComp[i].Nom,LesCategories.LesCategoriesComp[i]);
              end;
            ComboCatAss1.ItemIndex := 0;
            ComboCatAss2.ItemIndex := 1;
          end;
      end;
    ecConsult :
      begin
        BOK.Visible := False;
        BAnnuler.Visible := False;
        PCatSimple.Height := 56 + Nb * (EditNom.Height+5);
        if NbComp > 0 then
          begin
            PCatComp.Height := 56 + NbComp * (EditNom.Height+5);
            PCatComp.Visible := True;
          end;
      end;
  end;
  FormResize(nil);
  htf := Height-ClientHeight+ Panel1.Top + Panel1.Height;
  if htf < (Screen.Height - 50) then
    Height := htf;
end;


{procedure TFChoixcat.PCatCompDragLeave(Sender: TObject);
begin
  RectCible2.Visible := False;
end;
}


{
procedure TFChoixcat.PCatSimpleDragLeave(Sender: TObject);
begin
  RectCible.Visible := False;
end;
}

function TFChoixcat.CouleurSuivante : TColor32;
Var
  i,j : integer;
  OK : Boolean;
begin
  for i:= 0 to Length(MesCouleurs)-1 do
    begin
      Result := MesCouleurs[i];
      OK := True;
      for j := 0 to Nb-1 do
        if WinColor(MesCouleurs[i]) = LesCouleurs[j].Color then
          begin
            OK :=False;
            Break;
          end;
      for j := 0 to NbComp-1 do
        if WinColor(MesCouleurs[i]) = LesCouleursComp[j].Color then
          begin
            OK :=False;
            Break;
          end;
      if OK then
        Break;
    end;
end;
procedure TFChoixcat.Ajouter;
begin
  PeutChanger := False;
  if Etat = ecAjoutSimple then
    begin
      Inc(Nb);
      SetLength(LesNoms,Nb);
      LesNoms[Nb-1] := TEdit.Create(Self);
      LesNoms[Nb-1].Tag := Nb-1;
      LesNoms[Nb-1].Left:= EditNom.Left;
      LesNoms[Nb-1].Top := 26 + Nb * (EditNom.Height+5);
      LesNoms[Nb-1].Text := Trim(EditNom.Text);
      LesNoms[Nb-1].Font.Assign(EditNom.Font);
      LesNoms[Nb-1].Width := EditNom.Width;
      LesNoms[Nb-1].Height := EditNom.Height;
      LesNoms[Nb-1].Parent := PCatSimple;
      LesNoms[Nb-1].Visible := True;
      LesNoms[Nb-1].OnEnter := EDitEnter;
      LesNoms[Nb-1].DragMode :=TDragMode.dmManual;

      EditNom.Text := '';

      SetLength(LesCouleurs,Nb);
      LesCouleurs[Nb-1] := TPanel.Create(Self);
      LesCouleurs[Nb-1].Left := PanCouleur.Left;
      LesCouleurs[Nb-1].Top := LesNoms[Nb-1].Top;
      LesCouleurs[Nb-1].Width := PanCouleur.Width;
      LesCouleurs[Nb-1].Height:=PanCouleur.Height;
      LesCouleurs[Nb-1].Color := PanCouleur.Color;
      LesCouleurs[Nb-1].Tag:=LesNoms[Nb-1].Tag;
      LesCouleurs[Nb-1].OnClick:=CouleurClick;
      PanCouleur.Color := WinColor(CouleurSuivante);

      LesCouleurs[Nb-1].Parent := PCatSimple;
      Lescouleurs[Nb-1].Visible := True;

      SetLength(Actives,Nb);
      Actives[Nb-1] := TCheckBox.Create(Self);
      Actives[Nb-1].Left:= CheckActive.Left;
      Actives[Nb-1].Top := LesNoms[Nb-1].Top;
      Actives[Nb-1].Width := CheckActive.Width;
      Actives[Nb-1].Font.Assign(CheckActive.Font);
      Actives[Nb-1].Checked := CheckActive.Checked;
      Actives[Nb-1].Parent := PCatSimple;
      Actives[Nb-1].Visible := False;   //True
      Actives[Nb-1].Tag:=LesNoms[Nb-1].Tag;
      PCatSimple.Height := 26 + (Nb+1) * (EditNom.Height+5);
      if PNouvCatSimple.Visible then
        PCatSimple.Height := PCatSimple.Height + PNouvCatSimple.Height;
    end
  else if Etat = ecAjoutSimpleComp then
    begin
      Inc(Nb);
      SetLength(LesNoms,Nb);
      LesNoms[Nb-1] := TEdit.Create(Self);
      LesNoms[Nb-1].Tag := Nb-1;
      LesNoms[Nb-1].Left:= EditNom.Left;
      LesNoms[Nb-1].Top := 26 + Nb * (EditNom.Height+5);
      LesNoms[Nb-1].Text := Trim(EditNom.Text);
      LesNoms[Nb-1].Font.Assign(EditNom.Font);
      LesNoms[Nb-1].Width := EditNom.Width;
      LesNoms[Nb-1].Height := EditNom.Height;
      LesNoms[Nb-1].Parent := PCatSimple;
      LesNoms[Nb-1].Visible := True;
      LesNoms[Nb-1].OnEnter := EDitEnter;
      LesNoms[Nb-1].DragMode :=TDragMode.dmManual;

      EditNom.Text := '';

      SetLength(LesCouleurs,Nb);
      LesCouleurs[Nb-1] := TPanel.Create(Self);
      LesCouleurs[Nb-1].Left := PanCouleur.Left;
      LesCouleurs[Nb-1].Top := LesNoms[Nb-1].Top;
      LesCouleurs[Nb-1].Width := PanCouleur.Width;
      LesCouleurs[Nb-1].Height:=PanCouleur.Height;
      LesCouleurs[Nb-1].Color := PanCouleur.Color;
      LesCouleurs[Nb-1].Tag:=LesNoms[Nb-1].Tag;
      LesCouleurs[Nb-1].OnClick:=CouleurClick;
      PanCouleur.Color := WinColor(CouleurSuivante);

      LesCouleurs[Nb-1].Parent := PCatSimple;
      Lescouleurs[Nb-1].Visible := True;

      SetLength(Actives,Nb);
      Actives[Nb-1] := TCheckBox.Create(Self);
      Actives[Nb-1].Left:= CheckActive.Left;
      Actives[Nb-1].Top := LesNoms[Nb-1].Top;
      Actives[Nb-1].Width := CheckActive.Width;
      Actives[Nb-1].Font.Assign(CheckActive.Font);
      Actives[Nb-1].Checked := CheckActive.Checked;
      Actives[Nb-1].Parent := Self;
      Actives[Nb-1].Visible := False; //True
      Actives[Nb-1].Tag:=LesNoms[Nb-1].Tag;
      PCatSimple.Height := 26 + (Nb+1) * (EditNom.Height+5);
      if PNouvCatSimple.Visible then
        PCatSimple.Height := PCatSimple.Height + PNouvCatSimple.Height;
      Inc(NbComp);
      SetLength(LesNomsComp,NbComp);
      LesNomsComp[NbComp-1] := TEdit.Create(Self);
      LesNomsComp[NbComp-1].Tag := -1-NbComp;
      LesNomsComp[NbComp-1].Left:= EditNomComp.Left;
      LesNomsComp[NbComp-1].Top := 26 + NbComp * (EditNomComp.Height+5);
      LesNomsComp[NbComp-1].Text := Trim(EditNomComp.Text);
      LesNomsComp[NbComp-1].Font.Assign(EditNomComp.Font);
      LesNomsComp[NbComp-1].Width := EditNomComp.Width;
      LesNomsComp[NbComp-1].Height := EditNomComp.Height;
      LesNomsComp[NbComp-1].Parent := PCatComp;
      LesNomsComp[NbComp-1].Visible := True;
      LesNomsComp[NbComp-1].OnEnter := EDitEnter;
      LesNomsComp[NbComp-1].DragMode :=TDragMode.dmManual;

      EditNomComp.Text := '';
      SetLength(LesCouleursComp,NbComp);
      LesCouleursComp[NbComp-1] := TPanel.Create(Self);
      LesCouleursComp[NbComp-1].Left:= PanCouleurComp.Left;
      LesCouleursComp[NbComp-1].Top := LesNomsComp[NbComp-1].Top;
      LesCouleursComp[NbComp-1].Width := PanCouleurComp.Width;
      LesCouleursComp[NbComp-1].Height:=PanCouleurComp.Height;
      LesCouleursComp[NbComp-1].Color := PanCouleurComp.Color;
      LesCouleursComp[NbComp-1].Tag:=LesNomsComp[NbComp-1].Tag;
      LesCouleursComp[NbComp-1].OnClick:=CouleurClick;
      PanCouleurComp.Color := WinColor(CouleurSuivante);
      PanCouleur.Color := WinColor(CouleurSuivante);
      LesCouleursComp[NbComp-1].Parent := PCatComp;
      LescouleursComp[NbComp-1].Visible := True;

      SetLength(ActivesComp,NbComp);
      ActivesComp[NbComp-1] := TCheckBox.Create(Self);
      ActivesComp[NbComp-1].Left:= CheckActiveComp.Left;
      ActivesComp[NbComp-1].Top := LesNomsComp[NbComp-1].Top;
      ActivesComp[NbComp-1].Width := CheckActiveComp.Width;
      ActivesComp[NbComp-1].Font.Assign(CheckActiveComp.Font);
      ActivesComp[NbComp-1].Checked := CheckActiveComp.Checked;
      ActivesComp[NbComp-1].Parent := PCatComp;
      ActivesComp[NbComp-1].Visible := True;
      ActivesComp[NbComp-1].Tag:=LesNomsComp[NbComp-1].Tag;
      PCatComp.Height := 56 + NbComp * (EditNomComp.Height+5);
      if PNouvCatComp.Visible then
        PCatComp.Height := PCatComp.Height + PNouvCatComp.Height;
    end
  else if Etat = ecAjoutComp then
    begin
      Inc(NbComp);
      SetLength(LesNomsComp,NbComp);
      LesNomsComp[NbComp-1] := TEdit.Create(Self);
      LesNomsComp[NbComp-1].Tag := -1-NbComp;
      LesNomsComp[NbComp-1].Left:= EditNomComp.Left;
      LesNomsComp[NbComp-1].Top := 26 + NbComp * (EditNomComp.Height+5);
      LesNomsComp[NbComp-1].Text := Trim(EditNomComp.Text);
      LesNomsComp[NbComp-1].Font.Assign(EditNomComp.Font);
      LesNomsComp[NbComp-1].Width := EditNomComp.Width;
      LesNomsComp[NbComp-1].Height := EditNomComp.Height;
      LesNomsComp[NbComp-1].Parent := PCatComp;
      LesNomsComp[NbComp-1].Visible := True;
      LesNomsComp[NbComp-1].OnEnter := EDitEnter;
      LesNomsComp[NbComp-1].DragMode :=TDragMode.dmManual;

      EditNomComp.Text := '';

      SetLength(LesCouleursComp,NbComp);
      LesCouleursComp[NbComp-1] := TPanel.Create(Self);
      LesCouleursComp[NbComp-1].Left:= PanCouleurComp.Left;
      LesCouleursComp[NbComp-1].Top := LesNomsComp[NbComp-1].Top;
      LesCouleursComp[NbComp-1].Width := PanCouleurComp.Width;
      LesCouleursComp[NbComp-1].Height:=PanCouleurComp.Height;
      LesCouleursComp[NbComp-1].Color := PanCouleurComp.Color;
      LesCouleursComp[NbComp-1].Tag:=LesNomsComp[NbComp-1].Tag;
      LesCouleursComp[NbComp-1].OnClick:=CouleurClick;
      PanCouleurComp.Color := WinColor(CouleurSuivante);
      PanCouleur.Color := WinColor(CouleurSuivante);
      LesCouleursComp[NbComp-1].Parent := PCatComp;
      LescouleursComp[NbComp-1].Visible := True;

      SetLength(ActivesComp,NbComp);
      ActivesComp[NbComp-1] := TCheckBox.Create(Self);
      ActivesComp[NbComp-1].Left:= CheckActiveComp.Left;
      ActivesComp[NbComp-1].Top := LesNomsComp[NbComp-1].Top;
      ActivesComp[NbComp-1].Width := CheckActiveComp.Width;
      ActivesComp[NbComp-1].Font.Assign(CheckActiveComp.Font);
      ActivesComp[NbComp-1].Checked := CheckActiveComp.Checked;
      ActivesComp[NbComp-1].Parent := PCatComp;
      ActivesComp[NbComp-1].Visible := True;
      ActivesComp[NbComp-1].Tag:=LesNomsComp[NbComp-1].Tag;
      PCatComp.Height := 56 + NbComp * (EditNomComp.Height+5);
      if PNouvCatComp.Visible then
        PCatComp.Height := PCatComp.Height + PNouvCatComp.Height;
    end;
end;
procedure TFChoixcat.BAnnulerClick(Sender: TObject);
begin
  ModalResult := mrAbort;
  Close;
end;

procedure TFChoixcat.BFermerClick(Sender: TObject);
begin
  ModalResult := mrNone;
  Close;
end;

procedure TFChoixcat.FormResize(Sender: TObject);
begin
  PCatSimple.Top:=0;
  PCatSimple.Width:=ClientWidth-24;
  PCatComp.Width:=ClientWidth-24;
  Panel1.Width:=ClientWidth-24;
  PCatComp.Top:=PCatSimple.Top+PCatSimple.Height;
  if PCatComp.Visible then
    Panel1.Top:=PCatComp.Top+PCatComp.Height
  else
    Panel1.Top:=PCatSimple.Top+PCatSimple.Height;
  PCatSimple.Width:=ClientWidth;
  PCatComp.Width:=ClientWidth;
  Panel1.Width:=ClientWidth;
end;

procedure TFChoixcat.EditDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
Var
  p,i : integer;
  MonEdit,EditCible : TEdit;
begin
  if Sender <> Source then
    begin
      MonEdit := ( Source as TEdit);
      EditCible := ( Sender as TEdit);
      if (MonEdit <> nil) and (EditCible <> nil) and (MonEdit <> EditCible) then
        begin
          p := MonEdit.Tag;
          i := EditCible.Tag;
          if ((p>=0) and(i>=0))or(p<-1)and(i<-1) then
            begin
              EditSurvole := i;
              if (p>=0) then
                begin
                  if p>i then
                    RectCible.Top := 51 + i * (EditNom.Height+5)
                  else
                    RectCible.Top := 51 + (i+1) * (EditNom.Height+5);
                  RectCible.Visible := True;
                  RectCible2.Visible := False;
                  RectCible.Color := clAqua;
                end
              else
                begin
                  p := -2-p;
                  i := -2-i;
                  if p>i then
                    RectCible2.Top := 51 + i * (EditNom.Height+5)
                  else
                    RectCible2.Top := 51 + (i+1) * (EditNom.Height+5);
                  RectCible2.Visible := True;
                  RectCible.Visible := False;
                  RectCible2.Color := clAqua;
                end;
            end;
        end;
    end;
end;

procedure TFChoixcat.EditDragDrop(Sender, Source: TObject; X, Y: Integer);
Var
  p,i : integer;
  Nom : string;
  Couleur : TColor;
  Act,Interd : Boolean;
  MonEdit,EditCible : TEdit;
  MaCategorie : TCategorie;
begin
  if Sender <> Source then
    begin
      MonEdit := ( Source as TEdit);
      EditCible := ( Sender as TEdit);
      if (MonEdit <> nil) and (EditCible <> nil) and (MonEdit <> EditCible) then
        begin
          p := MonEdit.Tag;
          EditSurvole := EditCible.Tag;
          if (p >= 0) and (EditSurvole >= 0) then
            begin
              Nom := MonEdit.Text;
              Couleur := LesCouleurs[p].Color;
              Act := Actives[p].Checked;
              Interd := InterdireS[p];
              MaCategorie := MesCategoriesS[p];
              if p > EditSurvole then //on remonte dans la liste
                begin
                  for i := p downto EditSurvole + 1 do
                    begin
                      LesNoms[i].Text := LesNoms[i-1].Text;
                      LesCouleurs[i].Color := LesCouleurs[i-1].Color;
                      Actives[i].Checked := Actives[i-1].Checked;
                      MesCategoriesS[i] := MesCategoriesS[i-1];
                      InterdireS[i] := InterdireS[i-1];
                      Actives[i].Enabled := Not InterdireS[i];
                    end;
                  LesNoms[EditSurvole].Text := Nom;
                  LesCouleurs[EditSurvole].Color := Couleur;
                  Actives[EditSurvole].Checked := Act;
                  InterdireS[EditSurvole] := Interd;
                  Actives[EditSurvole].Enabled := Not InterdireS[EditSurvole];
                  MesCategoriesS[EditSurvole] := MaCategorie;
                end
              else if (p < EditSurvole) then  //on descend dans la liste
                begin
                   // indice du nouvel emplacement
                  for i := p to EditSurvole - 1 do
                    begin
                      LesNoms[i].Text := LesNoms[i+1].Text;
                      LesCouleurs[i].Color := LesCouleurs[i+1].Color;
                      Actives[i].Checked := Actives[i+1].Checked;
                      MesCategoriesS[i] := MesCategoriesS[i+1];
                      InterdireS[i] := InterdireS[i+1];
                      Actives[i].Enabled := Not InterdireS[i];
                    end;
                  LesNoms[EditSurvole].Text := Nom;
                  LesCouleurs[EditSurvole].Color := Couleur;
                  Actives[EditSurvole].Checked := Act;
                  MesCategoriesS[EditSurvole] := MaCategorie;
                  InterdireS[EditSurvole] := Interd;
                  Actives[EditSurvole].Enabled := Not InterdireS[EditSurvole];
                end;
            end
          else if ((-2-EditSurvole) > - 1) and ((-2-EditSurvole) < NbComp+1) and (p < -1) then
            begin
              p := -2-p;
              EditSurvole := -2-EditSurvole;
              Nom := MonEdit.Text;
              Couleur := LesCouleursComp[p].Color;
              Act := ActivesComp[p].Checked;
              Interd := InterdireC[p];
              MaCategorie := MesCategoriesC[p];
              if p > EditSurvole then //on remonte dans la liste
                begin
                  for i := p downto EditSurvole + 1 do
                    begin
                      LesNomsComp[i].Text := LesNomsComp[i-1].Text;
                      LesCouleursComp[i].Color := LesCouleursComp[i-1].Color;
                      ActivesComp[i].Checked := ActivesComp[i-1].Checked;
                      MesCategoriesC[i] := MesCategoriesC[i-1];
                      InterdireC[i] := InterdireC[i-1];
                      ActivesComp[i].Enabled := Not InterdireC[i];
                    end;
                  LesNomsComp[EditSurvole].Text := Nom;
                  LesCouleursComp[EditSurvole].Color := Couleur;
                  ActivesComp[EditSurvole].Checked := Act;
                  MesCategoriesC[EditSurvole] := MaCategorie;
                  InterdireC[EditSurvole] := Interd;
                  ActivesComp[EditSurvole].Enabled := Not InterdireC[EditSurvole];
                end
              else if (p < EditSurvole) then  //on descend dans la liste
                begin
                  // indice du nouvel emplacement
                  for i := p to EditSurvole - 1 do
                    begin
                      LesNomsComp[i].Text := LesNomsComp[i+1].Text;
                      LesCouleursComp[i].Color := LesCouleursComp[i+1].Color;
                      ActivesComp[i].Checked := ActivesComp[i+1].Checked;
                      MesCategoriesC[i] := MesCategoriesC[i+1];
                      InterdireC[i] := InterdireC[i+1];
                      ActivesComp[i].Enabled := Not InterdireC[i];
                    end;
                  LesNomsComp[EditSurvole].Text := Nom;
                  LesCouleursComp[EditSurvole].Color := Couleur;
                  ActivesComp[EditSurvole].Checked := Act;
                  MesCategoriesC[EditSurvole] := MaCategorie;
                  InterdireC[EditSurvole] := Interd;
                  ActivesComp[EditSurvole].Enabled := Not InterdireC[EditSurvole];
                end;
            end;
          Editsurvole := -1;
          RectCible2.Visible := False;
          RectCible.Visible := False;
        end;
    end;
end;
procedure TFChoixcat.PCatCompDragDrop(Sender, Source: TObject; X, Y: Integer);
Var
  p,i : integer;
  Nom : string;
  Couleur : TColor;
  Act : Boolean;
  MonEdit : TEdit;
  MaCategorie : TCategorie;
begin
  MonEdit := ( Source as TEdit);
  if MonEdit <> nil then
    begin
      p := MonEdit.Tag;
      if ((-2-EditSurvole) > - 1) and ((-2-EditSurvole) < NbComp+1) and (p < -1) then
        begin
          p := -2-p;
          EditSurvole := -2-EditSurvole;
          Nom := MonEdit.Text;
          Couleur := LesCouleursComp[p].Color;
          Act := ActivesComp[p].Checked;
          MaCategorie := MesCategoriesC[p];
          if p > EditSurvole then //on remonte dans la liste
            begin
              for i := p downto EditSurvole + 1 do
                begin
                  LesNomsComp[i].Text := LesNomsComp[i-1].Text;
                  LesCouleursComp[i].Color := LesCouleursComp[i-1].Color;
                  ActivesComp[i].Checked := ActivesComp[i-1].Checked;
                  MesCategoriesC[i] := MesCategoriesC[i-1];
                end;
              LesNomsComp[EditSurvole].Text := Nom;
              LesCouleursComp[EditSurvole].Color := Couleur;
              ActivesComp[EditSurvole].Checked := Act;
              MesCategoriesC[EditSurvole] := MaCategorie;
            end
          else if p < (EditSurvole - 1) then  //on descend dans la liste
            begin
              Dec(EditSurvole); // indice du nouvel emplacement  //** sans doute à supprimer
              for i := p to EditSurvole - 1 do
                begin
                  LesNomsComp[i].Text := LesNomsComp[i+1].Text;
                  LesCouleursComp[i].Color := LesCouleursComp[i+1].Color;
                  ActivesComp[i].Checked := ActivesComp[i+1].Checked;
                  MesCategoriesC[i] := MesCategoriesC[i+1];
                end;
              LesNomsComp[EditSurvole].Text := Nom;
              LesCouleursComp[EditSurvole].Color := Couleur;
              ActivesComp[EditSurvole].Checked := Act;
              MesCategoriesC[EditSurvole] := MaCategorie;
            end;
        end;
      Editsurvole := -1;
      RectCible2.Visible := False;
    end;
end;

procedure TFChoixcat.PCatCompDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var
  n,p : integer;
  MonEdit : TEdit;
begin
  p := -1;
  MonEdit := (Source as TEdit);
  if MonEdit <> nil then
    begin
      p := MonEdit.Tag;
      n := Round((Y-52)/(EditNom.Height+5));
      RectCible2.Top := 51 + n * (EditNom.Height+5);
      RectCible2.Visible := True;
      if (n>=0) then
        if n <= NbComp then
          EditSurvole := -2-n
        else
          EditSurvole := -2-NbComp;
      if (p <> EditSurvole) and (p <> EditSurvole+1) then
        begin
          Accept := True;
          RectCible2.Color := clAqua;
        end
      else
        begin
          Accept := False;
          RectCible2.Color := WinColor(clDarkRed32);
        end;
      Label12.Caption:='n : '+IntToStr(n)+' Edit déplacé : '+IntToStr(p)+' ; X : '+IntToStr(X)+ ' ; Y : ' + IntToStr(Y);
   end;
end;

procedure TFChoixcat.PCatSimpleDragDrop(Sender, Source: TObject; X, Y: Integer);
Var
  p,i : integer;
  Nom : string;
  Couleur : TColor;
  Act : Boolean;
  MonEdit : TEdit;
  MaCategorie : TCategorie;
begin
  MonEdit := ( Source as TEdit);
  if MonEdit <> nil then
    begin
      p := MonEdit.Tag;
      if (EditSurvole > -1) and (EditSurvole < Nb+1) and (p > -1) then // Edit Simple LesNoms[i] concernés
        begin
          Nom := MonEdit.Text;
          Couleur := LesCouleurs[p].Color;
          Act := Actives[p].Checked;
          MaCategorie := MesCategoriesS[p];
          if p > EditSurvole then //on remonte dans la liste
            begin
              for i := p downto EditSurvole + 1 do
                begin
                  LesNoms[i].Text := LesNoms[i-1].Text;
                  LesCouleurs[i].Color := LesCouleurs[i-1].Color;
                  Actives[i].Checked := Actives[i-1].Checked;
                  MesCategoriesS[i] := MesCategoriesS[i-1];
                end;
              LesNoms[EditSurvole].Text := Nom;
              LesCouleurs[EditSurvole].Color := Couleur;
              Actives[EditSurvole].Checked := Act;
              MesCategoriesS[EditSurvole] := MaCategorie;
            end
          else if p < (EditSurvole - 1) then  //on descend dans la liste
            begin
              Dec(EditSurvole); // indice du nouvel emplacement
              for i := p to EditSurvole - 1 do
                begin
                  LesNoms[i].Text := LesNoms[i+1].Text;
                  LesCouleurs[i].Color := LesCouleurs[i+1].Color;
                  Actives[i].Checked := Actives[i+1].Checked;
                  MesCategoriesS[i] := MesCategoriesS[i+1];
                end;
              LesNoms[EditSurvole].Text := Nom;
              LesCouleurs[EditSurvole].Color := Couleur;
              Actives[EditSurvole].Checked := Act;
              MesCategoriesS[EditSurvole] := MaCategorie;
            end;
        end;
      Editsurvole := -1;
      RectCible.Visible := False;
    end;
end;

procedure TFChoixcat.PCatSimpleDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var
  n,p : integer;
  MonEdit : TEdit;
begin
  p := -1;
  MonEdit := (Source as TEdit);
  if MonEdit <> nil then
    begin
      p := MonEdit.Tag;
      n := Round((Y-52)/(EditNom.Height+5));
      RectCible.Top := 51 + n * (EditNom.Height+5);
      RectCible.Visible := True;
      if n<0 then
        n := 0;
      if n <= Nb then
        EditSurvole := n
      else
        EditSurvole := Nb;
      if (p <> EditSurvole-1) and (p <> EditSurvole) then
        begin
          Accept := True;
          RectCible.Color := clAqua;
        end
      else
        begin
          Accept := False;
          RectCible.Color := Wincolor(clDarkRed32);
        end;
      Label12.Caption:='n : '+IntToStr(n)+' Edit déplacé : '+IntToStr(p)+' ; X : '+IntToStr(X)+ ' ; Y : ' + IntToStr(Y);
    end;
end;

procedure TFChoixcat.BOKClick(Sender: TObject);
Var
  UneCategorie : TCategorie;
  CatParent1,CatParent2 : TCategorie;
  MonMessage : string;
  i,j,n,n2,nca : integer;
  ASupprimer : Boolean;
  OKAj : Boolean;
begin
  if Etat = ecAjoutSimple then
    begin
      if Trim(EditNom.Text) = '' then
        begin
          MonMessage := 'Vous n''avez pas nommé la nouvelle catégorie';
          MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
          ModalResult := mrNone;
          exit;
        end;
      // Vérification de la non duplication des noms
      MonMessage := 'Le nom choisi a déjà été utilisé';
      for i := 0 to Nb - 1 do
        if LesNoms[i].Text = Trim(EditNom.Text) then
          begin
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            ModalResult := mrNone;
            exit;
          end;
      for i := 0 to NbComp - 1 do
        if LesNomscomp[i].Text = Trim(EditNom.Text) then
          begin
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            ModalResult := mrNone;
            exit;
          end;
      CatSimpleEnCours := nil;
      modalResult := mrOK;
    end
  else if Etat = ecAjoutSimpleComp then
    begin
      MonMessage := 'Le nom choisi a déjà été utilisé';
      for i := 0 to Nb - 1 do
        if LesNoms[i].Text = Trim(EditNomComp.Text) then
          begin
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            ModalResult := mrNone;
            exit;
          end;
      for i := 0 to NbComp - 1 do
        if LesNomscomp[i].Text = Trim(EditNomComp.Text) then
          begin
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            ModalResult := mrNone;
            exit;
          end;
      UneCategorie := TCategorie.Create;
      UneCategorie.Nom := EditNomComp.Text;
      UneCategorie.FComposite := True;
      SetLength(UneCategorie.CatParents,2);
      UneCategorie.CatParents[0] := CatSimpleEnCours;
      UneCategorie.CatParents[1] := CatRestr;
      n := Length(CatRestr.CatAscendants);
      SetLength(UneCategorie.CatAscendants,n+2);
      for i := 0 to n-1 do
        UneCategorie.CatAscendants[i] := CatRestr.CatAscendants[i];
      UneCategorie.CatAscendants[n] := CatSimpleEnCours;
      UneCategorie.CatAscendants[n+1] := CatRestr;
      Unecategorie.Lien := tlEt;
      Unecategorie.Couleur :=Color32(PanCouleurComp.Color);
      Unecategorie.Active := CheckActiveComp.Checked;
      LesCategories.AjouteComp(Unecategorie);
      CatSimpleEnCours := nil;
      modalResult := mrOK;
    end
  else if Etat = ecEditSimple then
    begin
      //Vérification de la non concordance des noms
      MonMessage := 'Vous avez choisi le même nom pour 2 catégories';
      for i := 0 to Nb - 1 do
        begin
          for j := i+1 to Nb - 1 do
            if LesNoms[i].Text = LesNoms[j].Text then
              begin
                MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
                ModalResult := mrNone;
                exit;
              end;
          for j := 0 to NbComp - 1 do
            if LesNoms[i].Text = LesNomsComp[j].Text then
              begin
                MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
                ModalResult := mrNone;
                exit;
              end;
        end;
      for i := 0 to NbComp - 2 do
        begin
          for j := i+1 to NbComp - 1 do
            if LesNomsComp[i].Text = LesNomsComp[j].Text then
              begin
                MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
                ModalResult := mrNone;
                exit;
              end;
        end;
      //Ajustement les noms des catégories
      for i := 0 to Nb - 1 do
        MesCategoriesS[i].Nom := LesNoms[i].Text;
      for i := 0 to NbComp - 1 do
        MesCategoriesC[i].Nom := LesNomsComp[i].Text;
      // Suppression des Catégories supprimées
      for i := 0 to LesCategories.NbCategorieDeBase - 1 do
        begin
          ASupprimer := True;
          for j := 0 to Nb - 1 do
            if LesCategories.LesCategoriesDeBase[i] = MesCategoriesS[j] then
              begin
                ASupprimer := False;
                Break;
              end;
          if ASupprimer then
            LesCategories.LesCategoriesDeBase[i].Free;
        end;
      for i := 0 to LesCategories.NbCategorieComp - 1 do
        begin
          ASupprimer := True;
          for j := 0 to NbComp - 1 do
            if LesCategories.LesCategoriesComp[i] = MesCategoriesC[j] then
              begin
                ASupprimer := False;
                Break;
              end;
          if ASupprimer then
            LesCategories.LesCategoriesComp[i].Free;
        end;
      // Ajustement des Catégories
      LesCategories.NbCategorieDeBase := Nb;
      SetLength(LesCategories.LesCategoriesDeBase,Nb);
      for i := 0 to Nb - 1 do
        begin
          MesCategoriesS[i].Nom := Trim(LesNoms[i].Text);
          MesCategoriesS[i].Couleur := Color32(LesCouleurs[i].Color);
          MesCategoriesS[i].Active := Actives[i].Checked;
          MesCategoriesS[i].Numero:=i;
          LesCategories.LesCategoriesDeBase[i] := MesCategoriesS[i];

        end;
      LesCategories.NbCategorieComp := NbComp;
      SetLength(LesCategories.LesCategoriesComp,NbComp);
      for i := 0 to NbComp - 1 do
        begin
          MesCategoriesC[i].Nom := Trim(LesNomsComp[i].Text);
          MesCategoriesC[i].Couleur := Color32(LesCouleursComp[i].Color);
          MesCategoriesC[i].Active := ActivesComp[i].Checked;
          MesCategoriesC[i].Numero:=i;
          LesCategories.LesCategoriesComp[i] := MesCategoriesC[i];
        end;

      ModalResult := mrOK;
      close;
    end
  else if Etat = ecAjoutComp then
    begin
      if Trim(EditNomcomp.Text) = '' then
        begin
          MonMessage := 'Vous n''avez pas nommé la nouvelle catégorie';
          MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
          ModalResult := mrNone;
          exit;
        end;
      // Vérification de la non duplication des noms
      MonMessage := 'Le nom choisi a déjà été utilisé';
      for i := 0 to Nb - 1 do
        if LesNoms[i].Text = Trim(EditNomcomp.Text) then
          begin
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            ModalResult := mrNone;
            exit;
          end;
      for i := 0 to NbComp - 1 do
        if LesNomsComp[i].Text = Trim(EditNomComp.Text) then
          begin
            MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
            ModalResult := mrNone;
            exit;
          end;

      //On vérifie si les catégories sont différentes
      CatParent1 := (ComboCatAss1.Items.Objects[ComboCatAss1.ItemIndex] as TCategorie);
      CatParent2 := (ComboCatAss2.Items.Objects[ComboCatAss2.ItemIndex] as TCategorie);
      if (CatParent1 <> nil) and (CatParent2 <> nil) then
        begin
          if (CatParent1 <> CatParent2) then
            begin
              UneCategorie := TCategorie.Create;
              UneCategorie.Nom := EditNomComp.Text;
              UneCategorie.FComposite := True;
              SetLength(UneCategorie.CatParents,2);
              UneCategorie.CatParents[0] := CatParent1;
              UneCategorie.CatParents[1] := CatParent2;

              if ComboLien.ItemIndex = 0 then
                Unecategorie.Lien := tlEt
              else
                Unecategorie.Lien :=tlOu;
              Unecategorie.Couleur :=Color32(PanCouleurComp.Color);
              Unecategorie.Active := CheckActiveComp.Checked;

              n := Length(CatParent1.CatAscendants);
              SetLength(UneCategorie.CatAscendants,n);
              for i := 0 to n-1 do
                begin
                  UneCategorie.CatAscendants[i] := CatParent1.CatAscendants[i];
                end;
              nca := n;
              n2 := Length(CatParent2.CatAscendants);
              SetLength(UneCategorie.CatAscendants,nca+n2);
              for i := 0 to n2-1 do
                begin
                  OKAj := True;
                  for j := 0 to n-1 do  // vérification pour éviter les doublons
                    if CatParent2.CatAscendants[i] = CatParent1.CatAscendants[j] then
                      begin
                        OKAj := False;
                        Break;
                      end;
                  if OKAj then
                    begin
                      inc(nca);
                      UneCategorie.CatAscendants[nca-1] := CatParent2.CatAscendants[i];
                    end;
                end;
              SetLength(UneCategorie.CatAscendants,nca+2);
              UneCategorie.CatAscendants[nca] := CatParent1;
              UneCategorie.CatAscendants[nca+1] := CatParent2;

              LesCategories.AjouteComp(Unecategorie);
              Ajouter;
              modalResult := mrOK;
            end
          else
            begin
              MonMessage := 'Les deux catégories sont identiques';
              MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
              modalResult := mrAbort;
              Close;
            end;
        end;
    end;
end;
procedure TFChoixcat.SupprimerComp(Ind : integer);
Var
  i : integer;
begin
  if (Ind > -1) and (Ind < NbComp) then
    begin
      for i := Ind to Nbcomp-2 do
        begin
          LesNomsComp[i].Text := LesNomsComp[i+1].Text;
          LesCouleursComp[i].Color := LesCouleursComp[i+1].Color;
          ActivesComp[i].Checked := ActivesComp[i+1].Checked;
          MesCategoriesC[i] := MesCategoriesC[i+1];
        end;
      Dec(NbComp);
      LesNomsComp[NbComp].Free;
      LesCouleursComp[NbComp].Free;
      ActivesComp[NbComp].Free;
      SetLength(LesNomsComp,NbComp);
      SetLength(LesCouleursComp,NbComp);
      SetLength(ActivesComp,NbComp);
      SetLength(MesCategoriesC,NbComp);//Ne pas supprimer la catégorie à ce stade (pour encore pouvoir annuler

      PCatComp.Height := 56 + NbComp * (EditNom.Height+5);

    end;
end;
procedure TFChoixcat.BSuppr2Click(Sender: TObject);
Var
  MonMessage : string;
  MonMessageL : Array of string;
  i,j : integer;
  CatDep : TGroupeCat;
  NS : integer;
  Interdire : Boolean;
begin
  if (NumSelect < - 1) and (Etat = ecEditSimple) then        //** vérifier les conséquences
    begin
      NS := -2-Numselect;
      // On vérifie d'abord que ce n'est pas CatRestr ni un de ses ancêtres
      Interdire  := (MesCategoriesC[NS] = CatRestr);
      if (Not Interdire) and (CatRestr <> nil) then
        begin
          for i := 0 to Length(CatRestr.CatAscendants)-1 do
            if CatRestr.CatAscendants[i] = MesCategoriesC[NS] then
              begin
                Interdire  := True;
                Break;
              end;
        end;
      if Interdire then
        begin
          MonMessage :='Vous ne pouvez supprimer la catégorie '+ CatRestr.Nom+' ni un de ses ancêtres';
          MessageDlg(MonMessage,mtError,[mbOK],0);
          Exit;
        end;

      LesCategories.ChercheDependantes(MesCategoriesC[NS],CatDep);
      SetLength(MonMessageL,1);
      MonMessageL[0] :='Voulez-vous supprimer la catégorie '+ LesNomscomp[NS].Text+' ?';
      if Length(CatDep) > 0 then
        begin
          SetLength(MonMessageL,3);
          MonMessageL[1] := 'Cela supprimera aussi les catégories qui en dépendent :';
          MonMessageL[2] := '  ';
          For i := 0 to Length(CatDep) - 1 do
            begin
              if i > 0 then
                MonMessageL[2] := MonMessageL[2] + ', ';
              MonMessageL[2] := MonMessageL[2] + CatDep[i].Nom;
            end;
        end;

      //if MessageDlg(MonMessage,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      if MessageOuiNon(MonMessageL) = mrYes then
        begin
          NumSelect := - 1;
          SupprimerComp(NS);
          BSuppr2.Visible := False;

          //Supprimer de la liste les catégories dépendantes dont les références figurent dans CatDep
          for i := 0 to NbComp - 1 do
            begin
              j := 0;
              while j < Length(CatDep) do
                if MesCategoriesC[i] = CatDep[j] then
                  begin
                    SupprimerComp(i);
                    Break;
                  end
                else
                  inc(j);
            end;
        end;
    end;
end;

procedure TFChoixcat.BSupprClick(Sender: TObject);
Var
  MonMessage : string;
  MonMessageL : array of string;
  i,j : integer;
  CatDep : TGroupeCat;
  Interdire : Boolean;
begin
  if (NumSelect > - 1) and (Etat = ecEditSimple) then
    begin
      // On vérifie d'abord que ce n'est pas CatRestr ni un de ses ancêtres
      Interdire  := (MesCategoriesS[NumSelect] = CatRestr);
      if (Not Interdire) and (CatRestr <> nil) then
        begin
          for i := 0 to Length(CatRestr.CatAscendants)-1 do
            if CatRestr.CatAscendants[i] = MesCategoriesS[NumSelect] then
              begin
                Interdire  := True;
                Break;
              end;
        end;
      if Interdire then
        begin
          MonMessage :='Vous ne pouvez supprimer la catégorie '+ CatRestr.Nom+' ni un de ses ancêtres';
          MessageDlg(MonMessage,TMsgDlgType.mtError,[mbOK],0);
          Exit;
        end;
      LesCategories.ChercheDependantes(MesCategoriesS[NumSelect],CatDep);
      SetLength(MonMessageL,1);
      MonMessageL[0] :='Voulez-vous supprimer la catégorie '+ LesNoms[NumSelect].Text+' ?';
      if Length(CatDep) > 0 then
        begin
          SetLength(MonMessageL,3);
          MonMessageL[1] := 'Cela supprimera aussi les catégories qui en dépendent :';
          MonMessageL[2] :='  ';
          For i := 0 to Length(CatDep) - 1 do
            begin
              if i > 0 then
                MonMessageL[2] := MonMessageL[2] + ', ';
                MonMessageL[2] := MonMessageL[2] + CatDep[i].Nom;
            end;
        end;

      //if MessageDlg(MonMessage,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      if MessageOuiNon(MonMessageL) = mrYes then
        begin
          for i := NumSelect to Nb-2 do
            begin
              LesNoms[i].Text := LesNoms[i+1].Text;
              LesCouleurs[i].Color := LesCouleurs[i+1].Color;
              Actives[i].Checked := Actives[i+1].Checked;
              MesCategoriesS[i] := MesCategoriesS[i+1];
            end;
          Dec(Nb);
          LesNoms[Nb].Free;
          LesCouleurs[Nb].Free;
          Actives[Nb].Free;
          SetLength(LesNoms,Nb);
          SetLength(LesCouleurs,Nb);
          SetLength(Actives,Nb);
          SetLength(MesCategoriesS,Nb); //Ne pas supprimer la catégorie à ce stade (pour encore pouvoir annuler
          NumSelect := - 1;
          BSuppr.Visible := False;
        end;
        PCatSimple.Height := 56 + Nb * (EditNom.Height+5);
        //Supprimer de la liste les catégories dépendantes dont les références figurent dans CatDep
        for i := 0 to NbComp - 1 do
          begin
            j := 0;
            while j < NbComp do
              if MesCategoriesC[i] = CatDep[j] then
                begin
                  SupprimerComp(i);
                  Break;
                end
              else
                inc(j);
          end;
    end;
end;

procedure TFChoixcat.CheckActiveChange(Sender: TObject);
begin
  if CheckActive.Checked then
    CheckActive.Caption := 'Oui'
  Else
    CheckActive.Caption := 'Non';
end;
procedure TFChoixcat.RAZ;
Var
  i : integer;
begin
  for i := Nb-1 Downto 0 do
    begin
      LesNoms[i].Free;
      LesCouleurs[i].Free;
      Actives[i].Free;
    end;
  Nb := 0;
  for i := NbComp-1 Downto 0 do
    begin
      LesNomsComp[i].Free;
      LesCouleursComp[i].Free;
      ActivesComp[i].Free;
    end;

  NbComp := 0;
  NumSelect := -1;
  SetLength(LesRestrictions,0);
  CatRestr := nil;
  CatSimpleEnCours := nil;
  SetLength(MesCategoriesS,0);
  SetLength(MesCategoriesC,0);
  SetLength(InterdireS,0);
  SetLength(InterdireC,0);
  PanCouleur.Color:=Wincolor(MesCouleurs[0]);
  PanCouleurComp.Color:=Wincolor(MesCouleurs[0]);
end;

procedure TFChoixcat.FormCreate(Sender: TObject);
begin
  Nb := 0;
  NbComp := 0;
  SetLength(MesCouleurs,16);
  MesCouleurs[0] := clRed32; //TColor32($FFFF0000);
  MesCouleurs[1] := clLimegreen32; //TColor32($FF32CD32);
  MesCouleurs[2] := clBlue32;//TColor32($FF0000FF);
  MesCouleurs[3] := clFuchsia32;//TColor32($FFFF00FF);
  MesCouleurs[4] := clChocolate32; //TColor32($FFD2691E);
  MesCouleurs[5] := clDarkGreen32; //TColor32($FF006400);
  MesCouleurs[6] := clDarkBlue32; //TColor32($FF00008B);
  MesCouleurs[7] := clDarkRed32;  //TColor32($FF8B0000);
  MesCouleurs[8] := clGold32;  //TColor32($FFFFD700);
  MesCouleurs[9] := clDarkCyan32; //TColor32($FF008B8B);
  MesCouleurs[10] := clHotPink32; //TColor32($FFFF69B4);
  MesCouleurs[11] := clGreenYellow32; //TColor32($FFADFF2F);
  MesCouleurs[12] := clOrange32; //TColor32($FFFFA500)
  MesCouleurs[13] := clAqua32;  //TColor32($FF00FFFF);
  MesCouleurs[14] := clDarkViolet32; //TColor32($FF9400D3);
  MesCouleurs[15] := clYellow32; //TColor32($FFFFFF00);
  EditSurvole := -1;
  NumSelect := -1;
  PanCouleur.Color:=Wincolor(MesCouleurs[0]);
  PanCouleurComp.Color:=Wincolor(MesCouleurs[0]);
end;

procedure TFChoixcat.CouleurClick(Sender: TObject);
Var
  i,n : integer; //,j
  //LaCouleur : TColor;
  LePanel : TPanel;
begin
  if PeutChanger then   //:= True;
    begin
      PeutChanger := False;
      LePanel := (Sender as TPanel);
      if LePanel <> nil then
        begin
          ColorDialog.Color := LePanel.Color;
          if ColorDialog.Execute then
            begin
              LePanel.Color := ColorDialog.Color;
              n := LePanel.Tag;
              for i := 0 to Nb-1 do
                begin
                  if (i <> n) and (LePanel.Color = LesCouleurs[i].Color) then
                    begin
                      PeutChanger := True;
                      LePanel.Color := WinColor(CouleurSuivante);
                      Exit;
                    end;
                end;
              for i := 0 to NbComp-1 do
                begin
                  if (i <>(-2 -n)) and (LePanel.Color = LesCouleursComp[i].Color) then
                    begin
                      LePanel.Color := WinColor(CouleurSuivante);
                      PeutChanger := True;
                      Exit;
                    end;
                end;
            end;
          PeutChanger := True;
        end;
    end;
end;

end.
