unit FormParams;
{$mode delphi}
interface
uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, Menus,
  StdCtrls,Buttons, ComCtrls, Spin,Donnees;

type

  { TFParams }

  TFParams = class(TForm)
    BEnregistrer: TButton;
    BOK: TBitBtn;
    Button2: TBitBtn;
    ActivParamSerie: TCheckBox;
    ChTousFichiers: TCheckBox;
    ComboFichiers: TComboBox;
    EditNomParamSeries: TEdit;
    EditUniteParamSeries: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LabProps: TLabel;
    LAlias: TLabel;
    LNoms: TLabel;
    LNoms1: TLabel;
    MainMenu1: TMainMenu;
    MRestreindre: TMenuItem;
    MFermer: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    ProgressBar: TProgressBar;
    SaveDialog: TSaveDialog;
    ScrollBox1: TScrollBox;
    procedure BEnregistrerClick(Sender: TObject);
    procedure ChTousFichiersClick(Sender: TObject);
    procedure MFermerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BOKClick(Sender: TObject);
    procedure ComboFichiersChange(Sender: TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    CBSels : Array of TCheckBox;
    ENoms : Array of TEdit;
    EAlias : Array of TEdit;
    LProps : Array of TLabel;
    ENomsSeries : Array of TEdit;
    CBSeries : Array of TCheckBox;
    ValSeries : Array of TSpinEdit;
    SerieDonnees : TDonneesCyto;
    AChange : Boolean;
    NbParams : integer;
    CatRestr : TCategorie;
    procedure AjusteValeurs;
    function initialise : Boolean;
    procedure Verifier;
    procedure MRestreindreClick(Sender : TObject);
  end;

var
  FParams: TFParams;

implementation

{$R *.lfm}
procedure TFParams.MRestreindreClick(Sender : TObject);
Var
  LeMenu : TMenuItem;
  n,i : integer;
begin
  LeMenu := TMenuItem(Sender);
  if LeMenu <> nil then
    begin
      LeMenu.Checked:= Not LeMenu.Checked;
      if LeMenu.Checked then
        begin
          n := LeMenu.Tag;
          if n <-1 then
            CatRestr := LesCategories.LesCategoriesComp[-2-n]
          else if n > -1 then
            CatRestr := LesCategories.LesCategoriesDeBase[n];
          for i := 0 to MRestreindre.Count - 1 do
            if MRestreindre.Items[i]<>LeMenu then
              MRestreindre.Items[i].Checked:=False;
        end
      else
        CatRestr := nil;
    end;
end;
procedure TFParams.BOKClick(Sender: TObject);
begin
  Verifier;
  Close;
end;
procedure TFParams.ComboFichiersChange(Sender: TObject);
begin
  Verifier;
  if ComboFichiers.ItemIndex > -1 then
    begin
      SerieDonnees := LesDonneesCyto[ComboFichiers.ItemIndex];
      if SerieDonnees <> nil then
        AjusteValeurs;
    end;
end;


procedure TFParams.Verifier;
Var
  i : integer;
  MonMessage : Array of string;
begin
  for i := 0 to Length(LesDonneesCyto) - 1 do
    if LesDonneesCyto[i].Nom <> Trim (ENomsSeries[i].Text) then
      begin
        SetLength(MonMessage,1);
        MonMessage[0] := 'Voulez-vous remplacer le nom de la série de données '+ LesDonneesCyto[i].Nom
                     + ' par '+ Trim (ENomsSeries[i].Text) + ' ?';
        if MessageOuiNon(MonMessage) = mrYes then
          begin
            LesDonneesCyto[i].Nom := Trim (ENomsSeries[i].Text);
            AChange := True;
          end;
      end;
  if ChTousFichiers.Checked then
    begin
      for i := 0 to Length(LesParams) - 1 do
        begin
          if LesParams[i].Alias <> Trim (EAlias[i].Text) then
            begin
              SetLength(MonMessage,1);
              MonMessage[0] := 'Voulez-vous remplacer le nom affiché '+ LesParams[i].Alias
                           + ' du paramètre '+LesParams[i].Nom + ' par '+ Trim (EAlias[i].Text) + ' ?';
              if MessageOuiNon(MonMessage) = mrYes then
                begin
                  LesParams[i].Alias := Trim (EAlias[i].Text);
                  AChange := True;
                end;
            end;
          if LesParams[i].Nom <> Trim (ENoms[i].Text) then
            begin
              SetLength(MonMessage,1);
              MonMessage[0] := 'Voulez-vous remplacer le nom du paramètre '+ LesParams[i].Nom
                           + ' par '+ Trim (ENoms[i].Text) + ' ?';
              if MessageOuiNon(MonMessage) = mrYes then
                begin
                  LesParams[i].Nom := Trim (ENoms[i].Text);
                  AChange := True;
                end;
            end;
        end;
    end
  else
    begin
      if SerieDonnees <> nil then
        begin
          For i :=0 to SerieDonnees.NbParam - 1 do
            begin
              if SerieDonnees.Parametres[i].Alias <> Trim (EAlias[i].Text) then
                begin
                  SetLength(MonMessage,1);
                  MonMessage[0] := 'Voulez-vous remplacer le nom affiché '+ SerieDonnees.Parametres[i].Alias
                               + ' du paramètre '+SerieDonnees.Parametres[i].Nom + ' par '+ Trim (EAlias[i].Text) + ' ?';
                  if MessageOuiNon(MonMessage) = mrYes then
                    begin
                      SerieDonnees.Parametres[i].Alias := Trim (EAlias[i].Text);
                      AChange := True;
                    end;
                end;
              if SerieDonnees.Parametres[i].Nom <> Trim (ENoms[i].Text) then
                begin
                  SetLength(MonMessage,1);
                  MonMessage[0] := 'Voulez-vous remplacer le nom du paramètre '+ SerieDonnees.Parametres[i].Nom
                               + ' par '+ Trim (ENoms[i].Text) + ' ?';
                  if MessageOuiNon(MonMessage) = mrYes then
                    begin
                      SerieDonnees.Parametres[i].Nom := Trim (ENoms[i].Text);
                      AChange := True;
                    end;
                end;
            end;
        end;
    end;
end;

procedure TFParams.FormCreate(Sender: TObject);
begin
  SetLength(ENoms,0);
  SetLength(EAlias,0);
  SetLength(LProps,0);
  SetLength(CBSels,0);
  NbParams := 0;
  AChange := False;
end;

procedure TFParams.MFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFParams.BEnregistrerClick(Sender: TObject);
Var
  i ,j,nd : integer;
  LeFichier : TFileStream;
  NmF : Ansistring;
  Dernier : Boolean;
begin
  if SaveDialog.Execute then
    begin
      Verifier;
      if ChTousFichiers.Checked then
        begin
          for i := 0 to Length(LesParams)-1 do
            LesParams[i].Sauvegarder:=CBSels[i].Checked;
          NmF := UTF8ToAnsi(SaveDialog.FileName);
          nd := -1;
          For i := Length(LesDonneesCyto) - 1 downto 0 do
            if CBSeries[i].Checked then
              begin
                nd :=i;
                Break;
              end;
          if nd > -1 then
            begin
              LeFichier := TFileStream.Create(NmF,fmOpenWrite or fmCreate);
              Try
                For i := 0 to nd do
                  begin
                    Dernier := (i = nd);
                    if ActivParamSerie.Checked then
                      begin
                        LesDonneesCyto[i].ParamSerie:=EditNomParamSeries.Text;
                        LesDonneesCyto[i].UniteParamSerie:=EditUniteParamSeries.Text;
                        LesDonneesCyto[i].ValeurParamSerie:=ValSeries[i].Value;
                      end
                    else
                      begin
                        LesDonneesCyto[i].ParamSerie:='';
                        LesDonneesCyto[i].UniteParamSerie:='';
                        LesDonneesCyto[i].ValeurParamSerie:=0;
                      end;
                    if CBSeries[i].Checked then
                      LesDonneesCyto[i].AjouteStreamFCS(CatRestr,ProgressBar,Dernier,LeFichier);
                  end;
              finally
                ProgressBar.Visible := False;
                LeFichier.Free;
              end;
            end;
        end
      else
        begin
          for i := 0 to SerieDonnees.NbParam - 1 do
            SerieDonnees.Parametres[i].Sauvegarder:=CBSels[i].Checked;
          SerieDonnees.EnregistreFCS(SaveDialog.FileName,CatRestr,ProgressBar);
          Close;
        end;
    end;
end;

procedure TFParams.ChTousFichiersClick(Sender: TObject);
begin
  //ChTousFichiers.Checked:=Not ChTousFichiers.Checked;
  ComboFichiers.Enabled:=Not ChTousFichiers.Checked;
  Verifier;
  AjusteValeurs;
end;


function TFParams.initialise : Boolean;
Var
  i, nb : integer;
begin
  if Length(LesDonneesCyto) > 0 then
    begin
      AChange := False;
      ComboFichiers.Clear;
      nb := Length(LesDonneesCyto);
      for i := Length(ENomsSeries)-1 downto 0 do
        begin
          ENomsSeries[i].Free;
          CBSeries[i].Free;
          ValSeries[i].Free;
        end;
      SetLength(ENomsSeries,nb);
      SetLength(CBSeries,nb);
      SetLength(ValSeries,nb);
      For i := 0 to nb - 1 do
        begin
          ComboFichiers.Items.Add(LesDonneesCyto[i].Nom);
          ENomsSeries[i] := TEdit.Create(Self);
          ENomsSeries[i].Left := 4;
          ENomsSeries[i].Width := 250;
          ENomsSeries[i].Height := 23;
          ENomsSeries[i].Top := (i+1)*32;
          ENomsSeries[i].Parent := Panel3;
          ENomsSeries[i].Text := LesDonneesCyto[i].Nom;
          CBSeries[i] := TCheckBox.Create(Self);
          CBSeries[i].Left := 260;
          CBSeries[i].Width := 20;
          CBSeries[i].Height := 19;
          CBSeries[i].Top := (i+1)*32;
          CBSeries[i].Parent := Panel3;
          CBSeries[i].Checked:=True;
          ValSeries[i] := TSpinEdit.Create(Self);
          ValSeries[i].Left:=320;
          ValSeries[i].Width:=80;
          ValSeries[i].Height:=23;
          ValSeries[i].Top:=(i+1)*32;
          ValSeries[i].Parent := Panel3;
          ValSeries[i].Value:=LesDonneesCyto[i].ValeurParamSerie;
        end;
      if LesDonneesCyto[0].ParamSerie <> '' then
        begin
          EditNomParamSeries.Text:=LesDonneesCyto[0].ParamSerie;
          EditUniteParamSeries.Text:=LesDonneesCyto[0].UniteParamSerie;
          ActivParamSerie.Checked:=True;
        end;

      Panel3.Height:= (nb+1)*32+8;
      ComboFichiers.ItemIndex := 0;
      SerieDonnees := LesDonneesCyto[0];
      Result := True;
      AjusteValeurs;
    end
  else
    Result := False;
end;
procedure TFParams.AjusteValeurs;
Var
  i : integer;
  Chaine : string;
  Nb : integer;
begin
  if ChTousFichiers.Checked then
    begin
      nb := Length(LesParams);
      for i := NbParams - 1 downto nb do
        begin
          CBSels[i].Free;
          ENoms[i].Free;
          EAlias[i].Free;
          LProps[i].Free;
        end;
      SetLength(ENoms, Nb);
      SetLength(EAlias, Nb);
      SetLength(LProps, Nb);
      SetLength(CBSels, Nb);
      for i := NbParams to nb - 1 do
        begin
          CBSels[i] := TCheckBox.Create(Panel2);
          CBSels[i].Left := 16;
          CBSels[i].Width := 20;
          CBSels[i].Height := 19;
          CBSels[i].Top := (i+1)*32;
          CBSels[i].Parent := Panel2;
          ENoms[i] := TEdit.Create(Panel2);
          ENoms[i].Left := 56;
          ENoms[i].Width := 105;
          ENoms[i].Height := 23;
          ENoms[i].Top := (i+1)*32;
          ENoms[i].Parent := Panel2;
          EAlias[i] := TEdit.Create(Panel2);
          EAlias[i].Left := 205;
          EAlias[i].Width := 105;
          EAlias[i].Height := 23;
          EAlias[i].Top := (i+1)*32;
          EAlias[i].Parent := Panel2;
          LProps[i] := TLabel.Create(Panel2);
          LProps[i].Left := 312;
          LProps[i].AutoSize := True;
          LProps[i].Top := (i+1)*32;
          LProps[i].Parent := Panel2;
        end;
      NbParams := nb;
      For i :=0 to Nb - 1 do
        begin
          CBSels[i].Checked:= True;
          ENoms[i].Text := LesParams[i].Nom;
          EAlias[i].Text := LesParams[i].Alias;
          Chaine := '  Résolution : '+IntToStr(LesParams[i].Resolution)
              +' Nombre de bits : '+ IntToStr(LesParams[i].NombreBits)+'   ';
          if LesParams[i].TypeEchelle = teLin then
            Chaine := Chaine + 'Lin   '
          else
            Chaine := Chaine + 'Log   ';
          Chaine := Chaine + FloatToStr(LesParams[i].Puis10Log);
          LProps[i].Caption := Chaine;
          ENoms[i].Visible := True;
          EAlias[i].Visible := True;
          LProps[i].Visible := True;
        end;
    end
  else
    begin
      if SerieDonnees <> nil then
        begin
          nb := SerieDonnees.NbParam;
          for i := NbParams - 1 downto nb do
            begin
              CBSels[i].Free;
              ENoms[i].Free;
              EAlias[i].Free;
              LProps[i].Free;
            end;
          SetLength(ENoms, Nb);
          SetLength(EAlias, Nb);
          SetLength(LProps, Nb);
          SetLength(CBSels, Nb);
          for i := NbParams to nb - 1 do
            begin
              CBSels[i] := TCheckBox.Create(Panel2);
              CBSels[i].Left := 16;
              CBSels[i].Width := 20;
              CBSels[i].Height := 19;
              CBSels[i].Top := (i+1)*32;
              CBSels[i].Parent := Panel2;
              ENoms[i] := TEdit.Create(Panel2);
              ENoms[i].Left := 56;
              ENoms[i].Width := 105;
              ENoms[i].Height := 23;
              ENoms[i].Top := (i+1)*32;
              ENoms[i].Parent := Panel2;
              EAlias[i] := TEdit.Create(Panel2);
              EAlias[i].Left := 205;
              EAlias[i].Width := 105;
              EAlias[i].Height := 23;
              EAlias[i].Top := (i+1)*32;
              EAlias[i].Parent := Panel2;
              LProps[i] := TLabel.Create(Panel2);
              LProps[i].Left := 312;
              LProps[i].AutoSize := True;
              LProps[i].Top := (i+1)*32;
              LProps[i].Parent := Panel2;
            end;
          NbParams := nb;
          For i :=0 to Nb - 1 do
            begin
              CBSels[i].Checked:= True;
              ENoms[i].Text := SerieDonnees.Parametres[i].Nom;
              EAlias[i].Text := SerieDonnees.Parametres[i].Alias;
              Chaine := '  Résolution : '+IntToStr(SerieDonnees.Parametres[i].Resolution)
                  +' Nombre de bits : '+ IntToStr(SerieDonnees.Parametres[i].NombreBits)+'   ';
              if SerieDonnees.Parametres[i].TypeEchelle = teLin then
                Chaine := Chaine + 'Lin   '
              else
                Chaine := Chaine + 'Log   ';
              Chaine := Chaine + FloatToStr(SerieDonnees.Parametres[i].Puis10Log);
              LProps[i].Caption := Chaine;
              ENoms[i].Visible := True;
              EAlias[i].Visible := True;
              LProps[i].Visible := True;
            end;
        end;
    end;
    Panel2.Height:=(nb+1)*32+8;
    Panel1.Top:=Panel2.Height;
{    if Panel2.Height>Panel3.Height then
      begin
        //
        //Panel3.Height:=Panel2.Height;
      end
    else
      begin
        //Panel1.Top:=Panel3.Height;
        //Panel2.Height:=Panel3.Height;
      end; }
end;
end.
