unit gestimpr;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Spin,
   GR32,GR32_Image, ExtCtrls, StdCtrls, Buttons, Menus, PrintersDlgs;

type

  { TFgestimp }

  TFgestimp = class(TForm)
    BConfig: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LabImprimante: TLabel;
    margehaut: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    margebas: TSpinEdit;
    Label4: TLabel;
    orientation: TRadioGroup;
    formatpage: TRadioGroup;
    OK: TBitBtn;
    BAnnuler: TBitBtn;
    Label5: TLabel;
    margegauche: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    margedroite: TSpinEdit;
    Label8: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label10: TLabel;
    Nombrecopies: TSpinEdit;
    centrevert: TButton;
    CentreHrz: TButton;
    Label11: TLabel;
    nblig: TSpinEdit;
    Label12: TLabel;
    nbcol: TSpinEdit;
    Label13: TLabel;
    espaces: TSpinEdit;
    Label14: TLabel;
    Panel4: TPanel;
    Label15: TLabel;
    PrinterSetupDialog: TPrinterSetupDialog;
    taillim: TLabel;
    Bverifier: TButton;
    Avertis: TPanel;
    Label16: TLabel;
    RAZ: TButton;
    imprimgris: TCheckBox;
    ImagePage: TImage32;
    procedure BConfigClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure centrevertClick(Sender: TObject);
    procedure CentreHrzClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure orientationClick(Sender: TObject);
    procedure margeChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure formatpageClick(Sender: TObject);
    procedure BverifierClick(Sender: TObject);
    procedure RAZClick(Sender: TObject);
    procedure nbligChange(Sender: TObject);
  private
    { Déclarations privées}
    hpage,lpage:integer;
    ajustement:boolean;
    MonBitmap : TBitmap32;
    procedure TraceCadre;
    //procedure TransformeGris(BitMap:TBitmap);

  public
    { Déclarations publiques}
    largeurpage,hauteurpage:integer;
    nbrlig,nbrcol:integer;
    Largdocmm,Hautdocmm:integer;
    Largcadremm,Hautcadremm:integer;
    Margegauchemm,Margedroitemm,Margehautmm,Margebasmm,espacemm:integer;
    CoefHautSLarg:double;
    Disponible : Boolean;
    procedure Imprime(LeBitmap:TBitmap32);
    procedure LanceImpression;
  end;

var
  Fgestimp: TFgestimp;

implementation
uses GR32_Filters,Printers,OSPrinters;
{$R *.lfm}

procedure TFgestimp.Imprime(LeBitmap : TBitmap32);
Var
  MonMessage : string;
  n : integer;
begin

{  if Printer <> nil then
    begin

      n := Printer.Printers.Count;
      if n >0 then
        ComboImprim.Items.Assign(Printer.Printers)
      else
        Disponible := False;
    end
  else
    Disponible := False;

  if Disponible then
    begin }
      MonBitmap.Assign(LeBitmap);
      if (MonBitmap.Width * MonBitmap.Height) > 0 then
        begin
          CoefHautSLarg := MonBitmap.Height/MonBitmap.Width;
          BVerifier.Visible:=True;
          Tracecadre;
          ShowModal;
        end;
{    end
  else
    begin
      MonMessage := 'Il n''y a pas d''imprimante disponible';
      MessageDlg(MonMessage,mtError,[mbOK],0);
    end;
}
end;

procedure TFgestimp.FormCreate(Sender: TObject);
begin
  lpage:=210;
  hpage:=297;
  nbrcol:=1;
  nbrlig:=1;
  CoefHautSLarg:=1;
  Largcadremm:=190;
  Hautcadremm:=277;
  Bverifier.visible:=True;
  Largeurpage:=lpage;
  Hauteurpage:=hpage;
  Margegauchemm:=10;
  Margedroitemm:=10;
  Margehautmm:=10;
  Margebasmm:=10;
  espacemm:=5;
  ajustement:=false;
  MonBitmap := TBitmap32.Create;
end;

procedure TFgestimp.BConfigClick(Sender: TObject);
begin
   if PrinterSetupDialog.Execute then
     begin
       if Printer.Orientation = poPortrait then
         Orientation.ItemIndex:=0
       else
         Orientation.ItemIndex:=1;
       OrientationClick(nil);
       LabImprimante.Caption:=Printer.PrinterName;
     end;
end;

procedure TFgestimp.centrevertClick(Sender: TObject);
Var
  moyenne:integer;
begin
  moyenne:=(margehaut.Value+margebas.Value) div 2;
  Margehaut.Value:=moyenne;
  Margebas.Value:=moyenne;
  Margehautmm:=moyenne;
  margebasmm:=moyenne;
end;

procedure TFgestimp.CentreHrzClick(Sender: TObject);
Var
  moyenne:integer;
begin
  moyenne:=(Margegauche.Value+Margedroite.Value) div 2;
  Margegauche.Value:=moyenne;
  Margedroite.Value:=moyenne;
  Margegauchemm:=moyenne;
  margedroitemm:=moyenne;
end;

procedure TFgestimp.OKClick(Sender: TObject);
begin
  LanceImpression;
  ModalResult := mrOK;
  Close;
end;

procedure TFgestimp.orientationClick(Sender: TObject);
begin
  if orientation.ItemIndex=0 then
    begin
      Printer.Orientation:=poPortrait;
      largeurpage:=lpage;
      hauteurpage:=hpage;
      ImagePage.Width:=130;
      ImagePage.Height:=183;
      ImagePage.Top:=16;
      ImagePage.Left:=392;
    end
  else
    begin
      Printer.Orientation:=poLandscape;
      ImagePage.Width:=183;
      ImagePage.Height:=130;
      ImagePage.Top:=40;
      ImagePage.Left:=368;  

      largeurpage:=hpage;
      hauteurpage:=lpage;
    end;
  Bverifier.Visible:=True;
  RAZClick(Sender);
end;

procedure TFgestimp.margeChange(Sender: TObject);
begin
  if ajustement then exit;
  try
    Margegauchemm:=Margegauche.Value;
    Margedroitemm:=Margedroite.Value;
    Margehautmm:=Margehaut.Value;
    Margebasmm:=Margebas.Value;
    espacemm:=Espaces.Value;
  except
  end;
  Bverifier.Visible:=True;
end;
procedure TFgestimp.tracecadre;
var
  valeur,dif:integer;
  i,j:integer;
  x0,Y0,ht,lg,dx,dy:integer;
  ecxy:real;
begin
  ajustement:=True;
  Valeur:=(largeurpage-margegauchemm-margedroitemm-(nbrcol-1)*espacemm)div nbrcol;
  if (Valeur>5) and (Round(Valeur * CoefHautSLarg)>5) then
    begin
      Largdocmm:=Valeur;
      Avertis.Visible:=False;
    end
  else
    begin
      Avertis.Visible:=True;
      ajustement:=false;
      Exit;
    end;
  Valeur:=(hauteurpage-margehautmm-margebasmm-(nbrlig-1)*espacemm)div nbrlig;
  if (Round(Largdocmm * CoefHautSLarg)>Valeur) then
    begin
      Hautdocmm:=Valeur;
      Largdocmm:=Round(Hautdocmm/CoefHautSLarg);
      dif:=largeurpage-margegauchemm-margedroitemm-LargDocmm*nbrcol-(nbrcol-1)*espacemm;
      if dif>1 then
        begin
          margegauchemm:=margegauchemm+(dif div 2);
          margedroitemm:=margedroitemm+(dif div 2);
          margegauche.Value:=margegauchemm;
          margedroite.Value:=margedroitemm;
        end;
    end
  else
    begin
      Hautdocmm:=Round(Largdocmm * CoefHautSLarg);
      dif:=hauteurpage-margehautmm-margebasmm-HautDocmm*nbrlig-(nbrlig-1)*espacemm;
      if dif>1 then
        begin
          margehautmm:=margehautmm+(dif div 2);
          margebasmm:=margebasmm+(dif div 2);
          margehaut.Value:=margehautmm;
          margebas.Value:=margebasmm;
        end;
    end;
  if Hautdocmm<5 then
    begin
      Avertis.Visible:=True;
      ajustement:=false;
      Exit;
    end;
  ajustement:=false;
  Largcadremm:=largeurpage-margedroitemm-margegauchemm;
  Hautcadremm:=hauteurpage-margebasmm-margehautmm;
  taillim.Caption:=IntToStr(Largdocmm)+' x '+IntToStr(Hautdocmm);
  ImagePage.Bitmap.Width:=ImagePage.Width;
  ImagePage.Bitmap.Height:=ImagePage.Height;
  ImagePage.Bitmap.Clear(clWhite32);
  ecxy:=183/297;
  X0:=Round(margegauchemm*ecxy);
  Y0:=Round(margehautmm*ecxy);
  ht:=Round(Hautdocmm*ecxy);
  lg:=Round(Largdocmm*ecxy);
  dX:=Round((Largdocmm+espacemm)*ecxy);
  dY:=Round((Hautdocmm+espacemm)*ecxy);
  For i:=0 to nbrlig-1 do
    For j:=0 to nbrcol-1 do
      begin
        ImagePage.Bitmap.FillRectS(X0+j*dX,Y0+i*dY,X0+j*dX+lg,Y0+i*dY+ht,clLightGray32);
      end;
  Avertis.Visible:=False;
  Bverifier.Visible:=False;
end;
procedure TFgestimp.FormActivate(Sender: TObject);
begin
  Bverifier.Visible:=True;
  Tracecadre;
end;

procedure TFgestimp.formatpageClick(Sender: TObject);
begin
  if formatpage.ItemIndex=0 then
    begin
      lpage:=210;
      hpage:=297;
    end
  else
    begin
      lpage:=297;
      hpage:=420;
    end;
  if orientation.ItemIndex=0 then
    begin
      largeurpage:=lpage;
      hauteurpage:=hpage;
    end
  else
    begin
      largeurpage:=hpage;
      hauteurpage:=lpage;
    end;
  Tracecadre;
  Bverifier.Visible:=True;
end;

procedure TFgestimp.BverifierClick(Sender: TObject);
begin
  tracecadre;
end;

procedure TFgestimp.RAZClick(Sender: TObject);
begin
  Ajustement:=true;
  Margehautmm:=10;
  Margebasmm:=10;
  Margegauchemm:=10;
  Margedroitemm:=10;
  Margehaut.Value:=10;
  Margebas.Value:=10;
  Margegauche.Value:=10;
  Margedroite.Value:=10;
  Ajustement:=false;
  tracecadre;
end;

procedure TFgestimp.nbligChange(Sender: TObject);
begin
  try
    nbrlig:=nblig.Value;
    nbrcol:=nbcol.Value;
    Bverifier.Visible:=True;
    RAZClick(Sender);
  except
  end;
end;

procedure TFgestimp.LanceImpression;
Var
  coeff:real;
  Rect:TRect;
  i,j,k,ncop:integer;
  hautimp,largimp,espacehimp,espacevimp,margehautimp,margegaucheimp:integer;
  BitmapTemp : TBitmap;
begin
  if orientation.ItemIndex=0 then
    Printer.Orientation:=poPortrait
  else
    Printer.Orientation:=poLandscape;
  coeff:=Printer.PageWidth/Fgestimp.largeurpage;
  hautimp:=Round(Hautdocmm * coeff);
  largimp:=Round(Largdocmm * coeff);
  espacevimp:=Round((Espacemm + Hautdocmm)* coeff);
  espacehimp:=Round((Espacemm + Largdocmm)* coeff);
  margehautimp:=Round(Margehautmm * coeff);
  margegaucheimp:=Round(MargeGauchemm * coeff);
  ncop:=Nombrecopies.Value;
  if imprimgris.checked then
    //TransformeGris(MonBitMap);
    GR32_Filters.ColorToGrayscale(Monbitmap,Monbitmap);
  Printer.Copies:=ncop;
  BitmapTemp := TBitmap.Create;
  try
    BitmapTemp.Assign(MonBitmap);
    Printer.BeginDoc;
    for j:=0 to Fgestimp.nbrlig-1 do
      for k:=0 to Fgestimp.nbrcol-1 do
        begin
          Rect.top:=margehautimp+j*espacevimp;
          Rect.left:=margegaucheimp+k*espacehimp;
          Rect.Bottom:=Rect.top+hautimp;
          Rect.right:=Rect.Left+largimp;
          Printer.Canvas.StretchDraw(Rect,BitmapTemp);
        end;
  finally
    Printer.EndDoc;
    BitmapTemp.Free;
  end;
end;

end.
